package cz.muni.fi.pb162.test.concentration;

/**
 * This class represents card that has color and a picture. Both color and picture 
 * distinguish one card pair from another. 
 *
 * <p>Created 28.11.2009 at 0:21:45.
 *
 * @author Rastislav Mirek <rmirek at mail.muni.cz>
 * @version %I%, %G%
 */
public class Card {

    private String color;
    private String picture;

    /**
     * Creates new Card.
     *
     * @param color Color of card. May not be {@code null}.
     * @param picture Card's picture. May not be {@code null}.
     */
    public Card(String color, String picture){
        if(color == null){
            throw new NullPointerException("color");
        }
        if(picture == null){
            throw new NullPointerException("picture");
        }
        this.color = color;
        this.picture = picture;
    }
    
    public boolean equals(Object obj) {
        if(obj instanceof Card) {
            Card newCard = (Card) obj;
            return newCard.color.equals(color) && newCard.picture.equals(picture);
        }
        return false;
    }
    
    public int hashCode() {
        int hash = 31;
        hash = 17 * hash + color.hashCode();
        hash = 17 * hash + picture.hashCode();
        return hash;
    }

    @Override
    public String toString() {
        return color + "/" + picture;
    }

}
